/*
 * This file is part of AEGIS
 *
 * Copyright (C) 2009-2010 Nokia Corporation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 * Author: Markku Savela
 */

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <err.h>
#include "librestok.h"

#ifdef HAVE_LINUX_AEGIS_CREDP_H
extern "C"
	{
#	include <linux/aegis/credp.h>
	}
#endif

// Simple command line utility to unload policy based on the
// path string.

int main(int argc, char **argv)
	{
#ifdef HAVE_LINUX_AEGIS_CREDP_H
	// Become a "resource manager", so that configuration can
	// loaded into the kernel (only succeeds with root).
	if (restok_be_manager())
		{
		warnx("Could not become a manager -- will try to unload the conf anyway");
		}
	const char *arg;
	while ((arg = *++argv) != NULL && --argc > 0)
		{
		if (credp_kunload(arg))
			warn("Failed unloading '%s'", arg);
		}
#else
	warnx("Cannot unload policies -- credp kernel API not available");
#endif
	exit(EXIT_SUCCESS);
	}

