/*
 * This file is part of AEGIS
 *
 * Copyright (C) 2009-2010 Nokia Corporation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 * Author: Markku Savela
 */
#ifndef STATUS_CNF_H
#define STATUS_CNF_H

#include "restok_cnf.h"

namespace STATUS
	{
	struct package
		{
		unsigned int flags;	// Package status flags
		size_t len;
		char name[];
		};

	struct configuration
		{
		struct RESTOK::configuration* cnf;
		struct RESTOK::atom* source;

		struct alloc_chunk* overflow;	// Additional/overflow memory allocations.

		static configuration *merge(const char *origin, struct RESTOK::configuration* cnf);
		void release();

		// Working space
		struct RESTOK::package *package;// The current package

		struct RESTOK::DB::db_header db;
		char spare[2000];		// Initial spare room for parsing.
		char data[];			// Start of the data
		};
	}
#endif
